-- by modelleicher
-- www.schwabenmodding.bplaced.net

JohnDeere6210RpAnimations = {};

function JohnDeere6210RpAnimations.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function JohnDeere6210RpAnimations:load(xmlFile)
	-- Zapfwellenstummel / Powershaft rotation
	self.stummelIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations#zapfwellenStummelIndex"));
	
	-- Zapfwellenstummel2 / Powershaft2 rotation
	self.stummel2Index = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations.Stummel2#zapfwellenStummel2Index"));
	
	-- Tachozeiger / Speedometer animation
	self.tachoZeiger = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations.TachoZeiger#zeigerIndex"));
	self.tachoZeigerMultiplicator = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.JohnDeere6210RpAnimations.TachoZeiger#multiplicator"), 10);
	self.tachoZeigerMaxRotation = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.JohnDeere6210RpAnimations.TachoZeiger#maxRotation"), 245);
	
	-- Temperaturzeiger / temperature Display animation
	self.temperaturZeiger = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations.TemperaturZeiger#zeigerIndex"));
	self.temperaturZeigerMaxRot = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.JohnDeere6210RpAnimations.TemperaturZeiger#maxRotation"));
	self.tempCnt = 0;
	
	-- Temperaturzeiger2 / temperature Display animation
	self.temperaturZeiger2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations.TemperaturZeiger2#zeigerIndex"));
	self.temperaturZeigerMaxRot2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.JohnDeere6210RpAnimations.TemperaturZeiger2#maxRotation"));
	self.tempCnt2 = 0;
	
	-- Tankleuchte leuchtet auf sobald im Tank zu wenig drin ist / warning light if fuel level low
	self.tankLeuchte = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.JohnDeere6210RpAnimations.TankLeuchte#index"));
	self.tankMinWarnLevel = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.JohnDeere6210RpAnimations.TankLeuchte#minWarnLevel"));
	setVisibility(self.tankLeuchte, false);
	
	-- Arme
	self.frontLinkageBottomArmRotNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm1#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode1, math.rad(-85), math.rad(0), math.rad(0));
	self.frontLinkageBottomArmRotNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontLinkageBottomArm2#rotationNode"));
	setRotation(self.frontLinkageBottomArmRotNode2, math.rad(-85), math.rad(0), math.rad(0));
end;

function JohnDeere6210RpAnimations:delete()
end;

function JohnDeere6210RpAnimations:mouseEvent(posX, posY, isDown, isUp, button)
end;

function JohnDeere6210RpAnimations:keyEvent(unicode, sym, modifier, isDown)
end;
-- Kotflgel / Frontfenders ein und ausblenden /blend on off 
function JohnDeere6210RpAnimations:changeFenders(state, noEventSend)
	setFenderStateEvent.sendEvent(self, state, noEventSend);
	self.fenderState = state;
	if self.fenderState then
		setVisibility(self.kotfluegelLinks, true);
		setVisibility(self.kotfluegelRechts, true);
		self.wheels[1].rotMax = Utils.degToRad(self.lenkWinkelMin);
		self.wheels[1].rotMin = Utils.degToRad(-self.lenkWinkelMinInner);
		self.wheels[2].rotMax = Utils.degToRad(self.lenkWinkelMinInner);
		self.wheels[2].rotMin = Utils.degToRad(-self.lenkWinkelMin);		
	else
		setVisibility(self.kotfluegelLinks, false);
		setVisibility(self.kotfluegelRechts, false);	
		self.wheels[1].rotMax = Utils.degToRad(self.lenkWinkelMax);
		self.wheels[1].rotMin = Utils.degToRad(-self.lenkWinkelMaxInner);
		self.wheels[2].rotMax = Utils.degToRad(self.lenkWinkelMaxInner);
		self.wheels[2].rotMin = Utils.degToRad(-self.lenkWinkelMax);		
	end;
end;-- ende Kotflgel / Frontfenders ein und ausblenden /blend on off 

function JohnDeere6210RpAnimations:update(dt)

	-- Kotflgel / Frontfenders ein und ausblenden /blend on off 
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.KotfluegelOnOff) then
			self:changeFenders(not self.fenderState);
		end;
	end; -- ende Kotflgel / Frontfenders ein und ausblenden /blend on off 
	if self:getIsActive() then
		if self.isMotorStarted then
			-- Ladekontrollleuchte / Batterie load light
			if self.ladeLeuchteOn == 1 then
				setVisibility(self.ladeLeuchte, true);
				if self.movingDirection ~= 0 then
					self.timerTrue = true;
				end;
				if self.timerTrue then
					self.ladeTimer = math.max(self.ladeTimer - 0.01, 0);
				end;
				if self.ladeTimer == 0 then
					setVisibility(self.ladeLeuchte, false);
					self.timerTrue = nil;
					self.ladeLeuchteOn = 0;
					self.ladeTimer = 1;
				end;
			end;
						
			-- Tankleuchte leuchtet auf sobald im Tank zu wenig drin ist / warning light if fuel level low
			local actualTankInhalt = 0;
			if self.fuelCapacity > 0 then
				actualTankInhalt = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
			end;
			if actualTankInhalt < self.tankMinWarnLevel then
				setVisibility(self.tankLeuchte, true);
			else
				setVisibility(self.tankLeuchte, false);
			end;
		
			-- Zapfwellenstummel / Powershaft rotation
			rotate(self.stummelIndex, 0,0,0.001*dt);
			
			-- Zapfwellenstummel2 / Powershaft2 rotation
			rotate(self.stummel2Index, 0,0,0.001*dt);
			
			-- Tachozeiger / speedometer animation
			self.kmhMath = math.min(100, math.max(0, self.lastSpeed*self.speedDisplayScale*3600));
			local zeigerRotation = self.kmhMath * self.tachoZeigerMultiplicator;
			if zeigerRotation <= self.tachoZeigerMaxRotation then
				setRotation(self.tachoZeiger, 0, -Utils.degToRad(zeigerRotation), 0);
			else
				setRotation(self.tachoZeiger, 0, -Utils.degToRad(self.tachoZeigerMaxRotation), 0);	
			end;
			
			-- Temperaturanzeiger / temperature display animation und / and berechnung / calculation
			if self.tempCnt < 3000 then
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = self.tempCnt + 0.5;
			elseif self.tempCnt > 3000 and self.tempCnt < 6000 then
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.2, 10000);			
			else
				setRotation(self.temperaturZeiger, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.05, 10000);
			end;
			if self.tempCnt2 < 3000 then
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = self.tempCnt2 + 0.8;
			elseif self.tempCnt2 > 3000 and self.tempCnt2 < 6000 then
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = math.min(self.tempCnt2 + 0.3, 10000);			
			else
				setRotation(self.temperaturZeiger2, 0, Utils.degToRad(-(self.temperaturZeigerMaxRot2/10000)*self.tempCnt2), 0);
				self.tempCnt2 = math.min(self.tempCnt2 + 0.04, 10000);
			end;	
		end;
	else
		self.tempCnt = math.max(self.tempCnt - 0.08, 0);
		self.tempCnt2 = math.max(self.tempCnt2 - 0.1, 0);
	end;

end;

function JohnDeere6210RpAnimations:draw()	
end;

